#ifndef _ERRORS_H
#pragma once
#define _ERRORS_H

enum Errors {
    ERealError,
    ESyntax,
    ESignal,
    ENoValue,
    EError,
    EFailure,
    ENotReady,
    EHalt,
    
    EVariableError, // a special error that we can change the 'errortext' part

    EInvalidNumericForm,
    EUnknownAddress,
    EInvalidEnd,
    EInvalidBreak,
    EProgramInterrupted, 
    EMachineResourcesExhausted, 
    EUnmatchedCommentOrQuote, 
    EWhenOrOtherwiseExpected, 
    EUnexpectedThenOrElse, 
    EUnexpectedWhenOrOtherwise,
    EUnexpectedOrUnmatchedEnd,
    EControlStackFull,
    EClauseTooLong,
    EInvalidCharacterInProgram,
    EIncompleteDoSelectIf,
    EInvalidHexadecimalOrBinaryString,
    ELabelNotFound,
    EUnexpectedProcedure,
    EThenExpected,
    EStringOrSymbolExpected,
    ESymbolExpected,
    EInvalidDataOnEndOfClause,
    EInvalidCharacterString,
    EInvalidDataString,
    EInvalidTraceRequest,
    EInvalidSubkeywordFound,
    EInvalidWholeNumber,
    EInvalidDoSyntax,
    EInvalidLeaveOrIterate,
    EEnvironmentNameTooLong,
    ENameOrStringTooLong,
    ENameStartsWithNumberOrPeriod,
    EInvalidExpressionResult,
    ELogicalValueNotZeroOrOne,
    EInvalidExpression,
    EUnmatchedLeftparenInExpression,
    EUnexpectedCommaOrRightparen,
    EInvalidTemplateOrPattern,
    EEvaluationStackOverflow,
    EIncorrectCallToRoutine,
    EBadArithmeticConversion,
    EArithmeticOverflowUnderflow,
    ERoutineNotFound,
    EFunctionDidNotReturnData,
    ENoDataSpecifiedOnFunctionReturn,
    EInvalidVariableReference,
    EFailureInSystemService,
    EInterpretationError,
    ELastError
    };

const char * const  ErrorText[] = {
    "Someone didn't set a proper error!",
    "Syntax Error",
    "Signal Error",
    "NoValue Error",
    "Error Error",
    "Failure Error",
    "NotReady Error",
    "Halt Error",

    "This should never get printed -- a bug!",

    "Invalid Numeric Form Setting",
    "Unknown Address",
    "Invalid End",
    "Invalid Break",
    "Program Interrupted", 
    "Machine Resources Exhausted", 
    "Unmatched Comment Or Quote", 
    "When Or Otherwise Expected", 
    "Unexpected Then Or Else",
    "Unexpected When Or Otherwise",
    "Unexpected Or Unmatched End",
    "Control Stack Full",
    "Clause Too Long",
    "Invalid Character In Program",
    "Incomplete Do/Select/If",
    "Invalid Hexadecimal Or Binary String",
    "Label Not Found",
    "Unexpected Procedure",
    "Then Expected",
    "String Or Symbol Expected",
    "Symbol Expected",
    "Invalid Data On End Of Clause",
    "Invalid Character String",
    "Invalid Data String",
    "Invalid Trace Request",
    "Invalid Subkeyword Found",
    "Invalid Whole Number",
    "Invalid Do Syntax",
    "Invalid Leave Or Iterate",
    "Environment Name Too Long",
    "Name Or String Too Long",
    "Name Starts With Number Or Period",
    "Invalid Expression Result",
    "Logical Value Not Zero Or One",
    "Invalid Expression",
    "Unmatched Leftparen In Expression",
    "Unexpected Comma Or Rightparen",
    "Invalid Template Or Pattern",
    "Evaluation Stack Overflow",
    "Incorrect Call To Routine",
    "Bad Arithmetic Conversion",
    "Arithmetic Overflow/Underflow",
    "Routine Not Found",
    "Function Did Not Return Data",
    "No Data Specified On Function Return",
    "Invalid Variable Reference",
    "Failure In System Service",
    "Interpretation Error",
    "This is the last error -- this shouldn't get printed"
    };

#endif
