// -*- C++ -*-
//--------------
//--- Glob.h ---
//--------------
/*
 * Responsibility: 
 * Role: 
 * Communications: 
 * Bugs & Caveats: 
 * Created: Mon Mar 16 15:41:34 1992 by rvillari
 * Maintainer: 
 * 
 * $Id: Glob.h,v 1.1 92/03/29 09:18:49 rvillari Exp Locker: rvillari $
 * $Log:	Glob.h,v $
 * Revision 1.1  92/03/29  09:18:49  rvillari
 * Initial revision
 * 
 * 
 * 
*/


// these are the globals of the REXX interpreter

#ifndef _Glob_h
#pragma once
#define _Glob_h 1

#include "MemoryFile.h"
#include "ArgStr.h"
#include <String.h>
#include "Implementation.h"
#include "RexxTokens.h"
#include "RexxClauses.h"
#include "Clause.h"
#include "InternalEnv.h"
#include "SymTabs.h"
#include "Builtin.h"
#include "ExternalQueue.h"
#include "Name.RexxStreamp.VHMap.h"

struct Glob {
  public:
    ExternalQueue GlobalQueue;

    MemoryFile Stage1; // used as input into rexxpp1
    MemoryFile Stage2; // used as output for rexxpp1 and input for rexxpp2
    MemoryFile Stage3; // output for rexxpp2 and input for rexxscan

    String DefaultExtension;
    ArgString Version;
    ArgString DefaultAddress;

    ArgString VariableError;

    int NestingLevel; // needed for comment processing in rexxpp1.l
    int LineNumber; // linenumbers
    int ClauseNumber; // what clause number are we on right now?

    // these will be set if these errors occur in rexxpp1.l
    int pp1_InvalidCharacter;
    int pp1_StringNotTerminated;
    int pp1_CommentNotTerminated;

    // set by rexx_yylex
    int rexx_InvalidHexOrBinString;

    SignalPending[MaxSignals];
    int SignalIsPending;
    Signals RaisedSignal; // when a signal is raised, this tells you which signal was raised
    RexxTokens* Tokens;
    RexxTokens* Tokens2;
    RexxClauses* Clauses;

    Clause* Clause; // filled in by yyparse()

    InternalEnv Environments;
    SymbolTables SymbolTables;

    NameRexxStreampVHMap Streams;

    Builtin BuiltinFunctions;

    Errors Error; // the error number that is associated with the error

    int UninitializedAccess;

    Reasons ReasonForReturn;
    ArgString ReturnValue;

    Glob();
   ~Glob();
    void Init();
};

#endif 
