#include "InternalData.h"
#include "support.h"

InternalData* InternalData::Copy() {
    InternalData* newdata = new InternalData;
    // copy the stuff here
    // inherited things are SignalLabels, SignalAction, SignalState, Addresses
    for (int i = 0; i < MaxSignals; i++) {
	newdata->SignalLabel[i] = SignalLabel[i];
	newdata->SignalAction[i] = SignalAction[i];
	newdata->SignalState[i] = SignalState[i];
	newdata->SignalDescription[i] = SignalDescription[i];
    }
    // inherit these new values
    newdata->SignalBeingProcessed = SignalBeingProcessed;
    newdata->currentaddress = currentaddress;
    newdata->previousaddress = previousaddress;
    newdata->source = source;
    newdata->Digits = Digits;
    newdata->Fuzz = Fuzz;
    newdata->Form = Form;
    newdata->ElapsedSeconds = ElapsedSeconds;
    newdata->ElapsedMicroSeconds = ElapsedMicroSeconds;
    newdata->SourceLoaded = SourceLoaded;
    newdata->Source = Source; // should consider using a pointer here -- costs may be too much to keep copying this when we create new internalenv's
    newdata->SourceOwner = 0; // when we make a copy, the 'owner' doesn't get inherited
    newdata->StartPC = StartPC;
    newdata->EndPC = EndPC;
    return newdata;
}

InternalData::InternalData() : HasSymbolTable(0) , Source(0) {
    for (int i = 0; i < MaxArguments; i++) ArgumentsOmitted[i] = 1;
    MakeDefault();
}

InternalData::~InternalData() {
    if (SourceOwner) delete Source; // if we own the source, we should be the one to delete it!
}

void InternalData::MakeDefault() {
    for (int i = 0; i < MaxSignals; i++) {
	SignalState[i] = Off;
	SignalAction[i] = ASignal;
    }
    SignalBeingProcessed = SigSignal; // default value
    currentaddress = GetDefaultAddress();
    Digits = 9;
    Fuzz = 0;
    Form = 0; // default (scientific)
    ElapsedSeconds = 0;
    ElapsedMicroSeconds = 0;
    SourceLoaded = 0;
    if (Source) {
	Source->clear();
	Source = 0;
    }
    SourceOwner = 0;
    StartPC = 0;
    EndPC = 0;
}
