#ifndef _INTERNALDATA_H
#pragma once
#define _INTERNALDATA_H

#include "ArgStr.h"
#include "Implementation.h"
#include "Errors.h"
#include "Enums.h"
#include "MemoryFile.h"

struct InternalData {
//    ArgString ReturnValue;
    
    // these tell us where we are allowed to start and end searching for a label!
    int StartPC;
    int EndPC;

    int SourceOwner; // flag that tells us that we should be the one to delete Source
    int SourceLoaded; // flag that tells us whether source is loaded
    MemoryFile* Source; // this contains the actual source program

    int HasSymbolTable;

    ArgString Arguments[MaxArguments];
    int ArgumentsOmitted[MaxArguments];

    ArgString SignalLabel[MaxSignals]; // what to do with this signal
    Actions SignalAction[MaxSignals]; // whether call or signal
    SignalValues SignalState[MaxSignals];
//    Reasons ReasonForReturn;
    ArgString currentaddress;
    ArgString previousaddress;

    ArgString source; // whether we are a FUNCTION, COMMAND, SUBROUTINE, etc. -- used in PARSE SOURCE ...

    int Digits;
    int Fuzz;
    int Form; // 0 = scientific, 1 = engineering

    long ElapsedSeconds;
    long ElapsedMicroSeconds;

    Signals SignalBeingProcessed; // set to the signal being processed
    ArgString SignalDescription[MaxSignals]; // the description of the last condition raised
    
    InternalData* Copy();
    void MakeDefault();
    InternalData();
    ~InternalData();
};

#endif


