// This may look like C code, but it is really -*- C++ -*-
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of GNU CC.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY.  No author or distributor
accepts responsibility to anyone for the consequences of using it
or for whether it serves any particular purpose or works at all,
unless he says so in writing.  Refer to the GNU CC General Public
License for full details.

Everyone is granted permission to copy, modify and redistribute
GNU CC, but only under the conditions described in the
GNU CC General Public License.   A copy of this license is
supposed to have been given to you along with GNU CC so you
can know your rights and responsibilities.  It should be in a
file named COPYING.  Among other things, the copyright notice
and this notice must be preserved on all copies.  
*/


#ifndef _InternalDatapSLStack_h
#ifdef __GNUG__
#pragma once
#pragma interface
#endif
#define _InternalDatapSLStack_h 1

#include "InternalDatap.SLList.h"
#include "InternalDatap.Stack.h"

class InternalDatapSLStack : public InternalDatapStack
{
  InternalDatapSLList     p;

public:
                InternalDatapSLStack();
                InternalDatapSLStack(const InternalDatapSLStack& s);
                ~InternalDatapSLStack();

  void          operator = (const InternalDatapSLStack&);

  void          push(InternalDatap& item);
  InternalDatap           pop();
  InternalDatap&          top();               
  void          del_top();

  int           empty();
  int           full();
  int           length();

  void          clear();

  int           OK();

};


inline InternalDatapSLStack::InternalDatapSLStack() :p() {}
inline InternalDatapSLStack::InternalDatapSLStack(const InternalDatapSLStack& a) : p(a.p) {}
inline InternalDatapSLStack::~InternalDatapSLStack() {}

inline void InternalDatapSLStack::push(InternalDatap& item)
{
  p.prepend(item);
}

inline InternalDatap InternalDatapSLStack::pop()
{
  return p.remove_front();
}

inline InternalDatap& InternalDatapSLStack::top()
{
  return p.front();
}

inline void InternalDatapSLStack::del_top()
{
  p.del_front();
}

inline void InternalDatapSLStack::operator =(const InternalDatapSLStack& s)
{
  p = s.p;
}

inline int InternalDatapSLStack::empty() 
{
  return p.empty();
}

inline int InternalDatapSLStack::full() 
{
  return 0;
}

inline int InternalDatapSLStack::length() 
{
  return p.length();
}

inline int InternalDatapSLStack::OK() 
{
  return p.OK();
}

inline void InternalDatapSLStack::clear() 
{
  p.clear();
}


#endif
