// This may look like C code, but it is really -*- C++ -*-
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of GNU CC.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY.  No author or distributor
accepts responsibility to anyone for the consequences of using it
or for whether it serves any particular purpose or works at all,
unless he says so in writing.  Refer to the GNU CC General Public
License for full details.

Everyone is granted permission to copy, modify and redistribute
GNU CC, but only under the conditions described in the
GNU CC General Public License.   A copy of this license is
supposed to have been given to you along with GNU CC so you
can know your rights and responsibilities.  It should be in a
file named COPYING.  Among other things, the copyright notice
and this notice must be preserved on all copies.  
*/


#ifndef _InternalDatapStack_h
#ifdef __GNUG__
#pragma once
#pragma interface
#endif
#define _InternalDatapStack_h

#include <builtin.h>

#include "InternalDatap.defs.h"

class InternalDatapStack
{
public:
                        InternalDatapStack();
  virtual              ~InternalDatapStack();

  virtual void          push(InternalDatap& item) = 0;
  virtual InternalDatap           pop() = 0;
  virtual InternalDatap&          top() = 0;               
  virtual void          del_top() = 0;

  virtual int           empty() = 0;
  virtual int           full() = 0;
  virtual int           length() = 0;

  virtual void          clear() = 0;

  void                  error(const char*);
  virtual int           OK() = 0;
};

inline InternalDatapStack::InternalDatapStack() {}


#endif
