// -*- C++ -*-
//---------------------
//--- MemoryFile.cc ---
//---------------------
/* 
 * Synopsis: 
 * Implementation Notes:
 * ToDo:
 * 
 * $Id: MemoryFile.cc,v 1.1 92/03/29 09:17:04 rvillari Exp Locker: rvillari $
 * $Log:	MemoryFile.cc,v $
Revision 1.1  92/03/29  09:17:04  rvillari
Initial revision

 *
 *
*/

#include "MemoryFile.h"
#include <stream.h>
#include <stdio.h>

MemoryFile::MemoryFile() : cp(0) {
}

MemoryFile& MemoryFile::operator=(MemoryFile& m) {
    if (&m == this) return *this;
    memfile = m.memfile;
    unputs = m.unputs;
    cp = m.cp;
    charp_ = m.charp_;
    length_ = m.length_;
}

MemoryFile::~MemoryFile() {
}

int MemoryFile::lines() {
    charp_ = (char*)memfile;
    if (memfile == "") return 0;
    int lines = 1;
    while (*charp_) {
	if (*charp_ == '\n') lines++;
	charp_++;
    }
    return lines;
}

char* MemoryFile::getline(int n) {
    static char line[256]; // here's where we keep a copy of the line
    strcpy(line, "");
    charp_ = (char*)memfile;
    int lines = 0;
    while (*charp_ && lines < n) {
	if (*charp_ == '\n') lines++;
	charp_++;
    }
    if (*charp_) {
	char* cp = line;
	while (*charp_ && *charp_ != '\n') {
	    *cp = *charp_;
	    cp++;
	    charp_++;
	}
	*cp = '\0'; // terminate the line
    }
    return line;
}

void MemoryFile::Debug() {
    cout << "Dump MemoryFile\n" << memfile << "\nEndDump\n";
}


int MemoryFile::input() {
    if (cp >= length_) return EOF;
    else {
//	char c = charp_[cp];
	char c = memfile[cp];
//	printf("%c %d\n", c, c);
	cp++;
	return c;
    }
}

void MemoryFile::unput(int c) {
    String cc = c;
    unputs = cc + unputs;
}

void MemoryFile::output(int c) {
    String cc = c;
    memfile += cc;
}

void MemoryFile::output(char* c) {
    String cc = c;
    memfile += cc;
}

void MemoryFile::reset() {
    cp = 0;
    charp_ = (char*)memfile;
    length_ = memfile.length();
}

void MemoryFile::clear() {
    memfile = "";
    reset();
}

void MemoryFile::LoadFromString(String& s) {
    memfile = s;
    reset();
}

int MemoryFile::LoadFromFile(String& f) {
    char buff[1024];
    memfile = "";
    FILE* in;
    if (!(in = fopen(f, "r"))) return 0;
    strcpy(buff,"");
    while (!feof(in)) {
	fgets(buff, 1024, in);
	memfile += buff;
	strcpy(buff,"");
    }
    fclose(in);
    reset();
    return 1;
}
