// This may look like C code, but it is really -*- C++ -*-
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of GNU CC.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY.  No author or distributor
accepts responsibility to anyone for the consequences of using it
or for whether it serves any particular purpose or works at all,
unless he says so in writing.  Refer to the GNU CC General Public
License for full details.

Everyone is granted permission to copy, modify and redistribute
GNU CC, but only under the conditions described in the
GNU CC General Public License.   A copy of this license is
supposed to have been given to you along with GNU CC so you
can know your rights and responsibilities.  It should be in a
file named COPYING.  Among other things, the copyright notice
and this notice must be preserved on all copies.  
*/


#ifndef _NameSymbolpMap_h
#ifdef __GNUG__
#pragma once
#pragma interface
#endif
#define _NameSymbolpMap_h 1

#include <Pix.h>
#include "Name.defs.h"

class NameSymbolpMap
{
protected:
  int                   count;
  Symbolp                   def;

public:
                        NameSymbolpMap(Symbolp  dflt);
  virtual              ~NameSymbolpMap();

  int                   length();                // current number of items
  int                   empty();

  virtual int           contains(Name& key);      // is key mapped?

  virtual void          clear();                 // delete all items

  virtual Symbolp&          operator [] (Name& key) = 0; // access contents by key

  virtual void          del(Name& key) = 0;       // delete entry

  virtual Pix           first() = 0;             // Pix of first item or 0
  virtual void          next(Pix& i) = 0;        // advance to next or 0
  virtual Name&          key(Pix i) = 0;          // access key at i
  virtual Symbolp&          contents(Pix i) = 0;     // access contents at i

  virtual int           owns(Pix i);             // is i a valid Pix  ?
  virtual Pix           seek(Name& key);          // Pix of key

  Symbolp&                  dflt();                  // access default val

  void                  error(const char* msg);
  virtual int           OK() = 0;                // rep invariant
};

inline NameSymbolpMap::~NameSymbolpMap() {}

inline int NameSymbolpMap::length()
{
  return count;
}

inline int NameSymbolpMap::empty()
{
  return count == 0;
}

inline Symbolp& NameSymbolpMap::dflt()
{
  return def;
}

inline NameSymbolpMap::NameSymbolpMap(Symbolp  dflt) :def(dflt)
{
  count = 0;
}


#endif
