// This may look like C code, but it is really -*- C++ -*-
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of GNU CC.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY.  No author or distributor
accepts responsibility to anyone for the consequences of using it
or for whether it serves any particular purpose or works at all,
unless he says so in writing.  Refer to the GNU CC General Public
License for full details.

Everyone is granted permission to copy, modify and redistribute
GNU CC, but only under the conditions described in the
GNU CC General Public License.   A copy of this license is
supposed to have been given to you along with GNU CC so you
can know your rights and responsibilities.  It should be in a
file named COPYING.  Among other things, the copyright notice
and this notice must be preserved on all copies.  
*/


#ifndef _NameSymbolpVHMap_h
#ifdef __GNUG__
#pragma once
#pragma interface
#endif
#define _NameSymbolpVHMap_h 1

#include "Name.Symbolp.Map.h"


class NameSymbolpVHMap : public NameSymbolpMap
{
protected:
  Name*           tab;
  Symbolp*           cont;
  char*          status;
  unsigned int   size;

public:
                NameSymbolpVHMap(Symbolp  dflt,unsigned int sz=DEFAULT_INITIAL_CAPACITY);
                NameSymbolpVHMap(NameSymbolpVHMap& a);
                ~NameSymbolpVHMap();

  Symbolp&          operator [] (Name& key);

  void          del(Name& key);

  Pix           first();
  void          next(Pix& i);
  Name&          key(Pix i);
  Symbolp&          contents(Pix i);

  Pix           seek(Name& key);
  int           contains(Name& key);

  void          clear(); 
  void          resize(unsigned int newsize = 0);

  int           OK();
};


inline NameSymbolpVHMap::~NameSymbolpVHMap()
{
  delete [size] tab;
  delete [size] cont;
  delete [size] status;
}

inline int NameSymbolpVHMap::contains(Name& key)
{
  return seek(key) != 0;
}

inline Name& NameSymbolpVHMap::key(Pix i)
{
  if (i == 0) error("null Pix");
  return *((Name*)i);
}

inline Symbolp& NameSymbolpVHMap::contents(Pix i)
{
  if (i == 0) error("null Pix");
  return cont[((unsigned)(i) - (unsigned)(tab)) / sizeof(Name)];
}


#endif
