/* $Header: /net/tony/users/rvillari/rexx/RCS/Name.defs.h,v 1.2 92/03/29 09:19:17 rvillari Exp Locker: rvillari $ */

// -*- C++ -*-
/*-------------------*/
/*--- Name.defs.h ---*/
/*-------------------*/
/*
 * 
 * 
 * Copyright (C) 1988 Free Software Foundation
 *     written by Doug Lea (dl@rocky.oswego.edu)
 * 
 * This file is part of GNU CC.
 * 
 * GNU CC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY.  No author or distributor
 * accepts responsibility to anyone for the consequences of using it
 * or for whether it serves any particular purpose or works at all,
 * unless he says so in writing.  Refer to the GNU CC General Public
 * License for full details.
 * 
 * Everyone is granted permission to copy, modify and redistribute
 * GNU CC, but only under the conditions described in the
 * GNU CC General Public License.   A copy of this license is
 * supposed to have been given to you along with GNU CC so you
 * can know your rights and responsibilities.  It should be in a
 * file named COPYING.  Among other things, the copyright notice
 * and this notice must be preserved on all copies.  
 * 
*/


#ifndef _Namedefs_h
#ifdef __GNUG__
#pragma once
#endif
#define _Namedefs_h 1

#include <String.h>
#include <builtin.h>
class Symbol;
class Builtin;
class RexxStream;

typedef RexxStream* RexxStreamp;
typedef String Name;
typedef Symbol* Symbolp;
typedef void (*Functionp)();

// equality operator
#ifndef NameEQ
#define NameEQ(a, b)  ((a) == (b))
#endif

// less-than-or-equal
#ifndef NameLE
#define NameLE(a, b)  ((a) <= (b))
#endif

// comparison : less-than -> < 0; equal -> 0; greater-than -> > 0
#ifndef NameCMP
#define NameCMP(a, b) ( ((a) <= (b))? (((a) == (b))? 0 : -1) : 1 )
#endif



// hash function
#ifndef NameHASH
extern unsigned int hash(Name&);
#define NameHASH(x)  hashpjw(x)
#endif

// initial capacity for structures requiring one

#ifndef DEFAULT_INITIAL_CAPACITY
#define DEFAULT_INITIAL_CAPACITY 10
#endif


#endif
