// -*- C++ -*-
//--------------------
//--- RexxNumber.h ---
//--------------------
/*
 * Responsibility: 
 * Role: 
 * Communications: 
 * Bugs & Caveats: 
 * Created: Mon Mar 23 13:29:17 1992 by rvillari
 * Maintainer: 
 * 
 * $Id: RexxNumber.h,v 1.1 92/03/29 09:19:21 rvillari Exp Locker: rvillari $
 * $Log:	RexxNumber.h,v $
 * Revision 1.1  92/03/29  09:19:21  rvillari
 * Initial revision
 * 
 * 
 * 
*/


#ifndef _RexxNumber_h
#define _RexxNumber_h 1
#include <Integer.h>

class ArgString;

class RexxNumber {
  private:
    Integer number;
    int exponent;
    int digits;
    int state; // +1 == overflow, -1 == underflow, 0 == ok
    void updatedigits(int = 1);
    void removetrailingzeros();
  public:
    RexxNumber(const ArgString&, int);
    RexxNumber(long);
    RexxNumber();
   ~RexxNumber();
    RexxNumber& operator=(const RexxNumber&);
    RexxNumber& operator=(long);
    RexxNumber(const RexxNumber&);
    long Whole() const; // returns -999999999 -> 999999999  or MAXLONG to indicate failure to convert it into a whole number
    int IsAWhole() const;
    int ugreater(const RexxNumber&) const;
    int greater(const RexxNumber&) const;
    void negate();
    int sign() const;
    void Debug() const;
    friend int add(const RexxNumber&, const RexxNumber&, int, RexxNumber&);
    friend int subtract(const RexxNumber&, const RexxNumber&, int, RexxNumber&);
    friend int multiply(const RexxNumber&, const RexxNumber&, int, RexxNumber&);
    friend int divide(const RexxNumber&, const RexxNumber&, int, RexxNumber&);
    friend int power(const RexxNumber&, const RexxNumber&, int, RexxNumber&);
    friend int integerdivide(const RexxNumber&, const RexxNumber&, int, RexxNumber&, RexxNumber&);

    friend const RexxNumber& round(const RexxNumber&, int);
    friend const RexxNumber& trunc(const RexxNumber&, int);
    friend const ArgString& Form(const RexxNumber&, int, int = 0);
    friend const ArgString& Format(const RexxNumber&, int Digits, int Type = 0, int before = 01, int after = -1, int expp = -1, int expt = -1);
    friend const ArgString& Truncate(const RexxNumber&, int, int);
};

#endif 
