#ifndef _REXXTOKENS_H
#pragma once
#define _REXXTOKENS_H

#include "ArgStr.h"
#include "Implementation.h"
#include "RexxTokenp.XPlex.h"

class RexxToken {
  private:
    int type;
    int secondary;
    ArgString value;
  public:
    RexxToken(int = 0);
    ~RexxToken();
    ArgString* Value();
    // type is TOK_????
    int Type();
    // secondary TOK_SIMPLE, TOK_STEM, TOK_COMPOUND
    int Secondary();
    void Set(int, int, ArgString);
};

/* really simplistic array implementation! */
class RexxTokens {
  private:
//    RexxToken tokens[MaxTokens];
    RexxTokenpXPlex tokens;
    int finalpc;
    int pc;
  public:
    RexxTokens();
    ~RexxTokens();
    void ResetPC();
    void Backup(); // backs up one
    void CheckBound(int);
    void clear(); // empty everything out
    int LastTokenType(); // returns type of last token
    void AddToken(int, int, ArgString); // adds new token
    void AddToken(int, int, char*); // adds new token
    void AddToken(int, char*); // add new token
    void AddToken(int); // add new token
    RexxToken& NextToken();
    RexxToken& operator[](int);
    void Dump(); // dump
/*
    int GetPC();
    void SetPC(int);
    void IncPC(void);
*/
};
    





#endif
