#ifndef _SYMBOLTABLE_H
#pragma once
#define _SYMBOLTABLE_H

#include "Name.Symbolp.VHMap.h"
class ArgString;

class SymbolTable {
  private:
    NameSymbolpVHMap table;
  public:
    SymbolTable();
    ~SymbolTable();

    const Symbol* GetSymbol(String&, const Symbol* = 0) const; // returns actual symbol
    const Symbol* GetStemSymbol(String&, const Symbol* = 0) const; //
    const Symbol* GetCompoundSymbol(String&, const Symbol* = 0) const; // returns a compound symbol

    void Drop(String&);
    void DropStem(String&);
    void DropCompound(String&);

    String& Expand(String&) const;

    // regular access functions
    const ArgString& Read(String&, const Symbol* = 0) const;
    const ArgString& ReadStem(String&, const Symbol* = 0) const;
    const ArgString& ReadCompound(String&, const Symbol* = 0) const;

    void Write(String&, const ArgString&);
    void WriteStem(String&, const ArgString&);
    void WriteCompound(String&, const ArgString&);
};

#endif
