#include "Symbol.h"
#include "ArgStr.h"
#include "Name.Symbolp.VHMap.h"
#include <String.h>

Symbol::Symbol(const void* s) : owner(s), state(0) {
    // start off as an invalid symbol
}

Symbol::Symbol(const ArgString& v, const void* s) : value(v), owner(s), state(1) {
}

Symbol::~Symbol() {
}

void Symbol::Drop() {
    //value.Invalidate(); // leave it uninitialized again
    state = 0;
}

//

Stem::Stem(const void* s) : table(0), Symbol(s) {
}

Stem::Stem(const ArgString& v, const void* s) : table(0), Symbol(v, s) {}

Stem::~Stem() {
    for (Pix i = table.first(); i != 0; table.next(i))
	if (table.contents(i)->IsOwnedBy(this)) {
	    delete table.contents(i);
	}
}


void Stem::Drop() {
    Symbol::Drop(); // drop our default value!
    for (Pix i = table.first(); i != 0; table.next(i))
	table.contents(i)->Drop();
}

void Stem::Drop(const String& s) {
    if (table.contains(s)) table[s]->Drop();
}







