// This may look like C code, but it is really -*- C++ -*-
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of GNU CC.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY.  No author or distributor
accepts responsibility to anyone for the consequences of using it
or for whether it serves any particular purpose or works at all,
unless he says so in writing.  Refer to the GNU CC General Public
License for full details.

Everyone is granted permission to copy, modify and redistribute
GNU CC, but only under the conditions described in the
GNU CC General Public License.   A copy of this license is
supposed to have been given to you along with GNU CC so you
can know your rights and responsibilities.  It should be in a
file named COPYING.  Among other things, the copyright notice
and this notice must be preserved on all copies.  
*/


#ifndef _SymbolTablepSLStack_h
#ifdef __GNUG__
#pragma once
#pragma interface
#endif
#define _SymbolTablepSLStack_h 1

#include "SymbolTablep.SLList.h"
#include "SymbolTablep.Stack.h"

class SymbolTablepSLStack : public SymbolTablepStack
{
  SymbolTablepSLList     p;

public:
                SymbolTablepSLStack();
                SymbolTablepSLStack(const SymbolTablepSLStack& s);
                ~SymbolTablepSLStack();

  void          operator = (const SymbolTablepSLStack&);

  void          push(SymbolTablep& item);
  SymbolTablep           pop();
  SymbolTablep&          top();               
  void          del_top();

  int           empty();
  int           full();
  int           length();

  void          clear();

  int           OK();

};


inline SymbolTablepSLStack::SymbolTablepSLStack() :p() {}
inline SymbolTablepSLStack::SymbolTablepSLStack(const SymbolTablepSLStack& a) : p(a.p) {}
inline SymbolTablepSLStack::~SymbolTablepSLStack() {}

inline void SymbolTablepSLStack::push(SymbolTablep& item)
{
  p.prepend(item);
}

inline SymbolTablep SymbolTablepSLStack::pop()
{
  return p.remove_front();
}

inline SymbolTablep& SymbolTablepSLStack::top()
{
  return p.front();
}

inline void SymbolTablepSLStack::del_top()
{
  p.del_front();
}

inline void SymbolTablepSLStack::operator =(const SymbolTablepSLStack& s)
{
  p = s.p;
}

inline int SymbolTablepSLStack::empty() 
{
  return p.empty();
}

inline int SymbolTablepSLStack::full() 
{
  return 0;
}

inline int SymbolTablepSLStack::length() 
{
  return p.length();
}

inline int SymbolTablepSLStack::OK() 
{
  return p.OK();
}

inline void SymbolTablepSLStack::clear() 
{
  p.clear();
}


#endif
