// -*- C++ -*-
//------------------
//--- Variable.h ---
//------------------
/*
 * Responsibility: 
 * Role: 
 * Communications: 
 * Bugs & Caveats: 
 * Created: Tue Apr 21 16:06:33 1992 by rvillari
 * Maintainer: 
 * 
 * $Id$
 * $Log$
 * 
 * 
*/


#ifndef _Variable_h
#define _Variable_h 1

#include <String.h>
#include <ArgStr.h>
#include "SymTabs.h"
#include "Symbol.h"

class Variable {
  private:
    SymbolTable* symboltable;
  public:
    Variable();
    virtual ArgString& Read() = 0;
    virtual void Write(ArgString&) = 0;
    SymbolTable* CurrentTable();
    int HasChanged();
};

class FixedVariable : public Variable {
  private:
    ArgString name;
  public:
    FixedVariable(String&);
    virtual ArgString& Read();
    virtual void Write(ArgString&);
};

class SimpleVariable : public Variable {
  private:
    String name;
    Symbol* symbol;
  public:
    SimpleVariable(String&);
    virtual ArgString& Read();
    virtual void Write(ArgString&);
};

class StemVariable : public Variable {
  private:
    String name;
    Stem* stem;
  public:
    StemVariable(String&);
    virtual ArgString& Read();
    virtual void Write(ArgString&);
};

class CompoundVariable : public Variable {
  private:
    Stem* stem;
    String stemname;
    Variable** variables;
    int nodes;
    String& Expand();
  public:
    CompoundVariable(String&);
    virtual ArgString& Read();
    virtual void Write(ArgString&);
};

#endif 
