%{
/*
   - process commas for end-of-line terminators
*/
#include "MemoryFile.h"
#include "Glob.h"

extern Glob glob;

// stage 2 is input, glob.Stage3 is output
#define yylex pp2_lex
#undef YY_INPUT
#define YY_INPUT(buf, result, max_size) {int c = glob.Stage2.input(); result = (c==EOF) ? YY_NULL : (buf[0] = c, 1);}

%}

%x comment dquote squote

digit	[0-9]
char    [a-zA-Z]
dot     [.]
other   [!?$_]
any     [0-9a-zA-Z.!?$_]
nodot   [0-9a-zA-Z!?$_]
ws      [\t ]*

%%

%{
/* operators and stuff */
%}

[\t ]+                  { glob.Stage3.output(' '); }

\"               {BEGIN dquote;
                  glob.Stage3.output('"');
	         }

<dquote>\"\"     {glob.Stage3.output('"'); glob.Stage3.output('"');
	         }

<dquote>[^"\n]*  {int i;
                  for (i = 0; i < strlen(yytext); i++) glob.Stage3.output(yytext[i]);
                 }

<dquote>\n       {}

<dquote>\"       {BEGIN 0; glob.Stage3.output('"');}

\'               {BEGIN squote;
                  glob.Stage3.output('\'');
	         }

<squote>\'\'     {glob.Stage3.output('\''); glob.Stage3.output('\'');
	         }

<squote>[^'\n]*  {int i;
                  for (i = 0; i < strlen(yytext); i++) glob.Stage3.output(yytext[i]);
                 }

<squote>\n       {}

<squote>\'       {BEGIN 0; glob.Stage3.output('\'');}

{ws}","{ws}\n#{digit}+\n {/* Also remove this from the input */
               		glob.Stage3.output(' ');
			}

{ws}","{ws}\n       {/*  Remove from the input.  This is the continuation
                           character.  */
                        glob.Stage3.output(' '); /* replace with an implied space */
                        }

{ws}"\n"{ws}             { glob.Stage3.output('\n'); }

<<EOF>>  {yyrestart(0); yyterminate();}

.                       {glob.Stage3.output(yytext[0]);}

%%

/*
main() {
    yylex();
}
*/

