#ifndef _STRINGSUPPORT_H
#pragma once
#define _STRINGSUPPORT_H

class ArgString;

ArgString space(ArgString&); // removes unnecessary spaces
int split(ArgString&, ArgString [], int);
ArgString xrange(unsigned char, unsigned char);
ArgString lower(ArgString&);
ArgString upper(ArgString&);
ArgString stripfront(ArgString&, char = ' ');
ArgString striprear(ArgString&, char = ' ');
ArgString reverse(ArgString&);
int validhex(ArgString&);
int validbin(ArgString&);
int validnumber(const ArgString&);
ArgString packhex(ArgString&);
ArgString packbin(ArgString&);
char bintochar(char, char, char, char, char, char, char, char);
char hextochar(char, char);
char chartohex(char);
char bintohex(char, char, char, char);
ArgString padonright(ArgString&, int, char);
ArgString padonleft(ArgString&, int, char);
ArgString right(ArgString&, int, char);
ArgString left(ArgString&, int, char);
ArgString c2d(ArgString&, int);
ArgString uc2d(ArgString&);
ArgString ud2c(ArgString&);
ArgString ud2x(ArgString&);
ArgString twocomplement(ArgString&);
ArgString xtwocomplement(ArgString&);
int isalphanumeric(ArgString&);
int islower(ArgString&);
int ismixed(ArgString&);
int issymbol(ArgString&);
int issscsymbol(ArgString&); // stem, simple, compound symbol
int issimplesymbol(ArgString&); // simple
int isstemsymbol(ArgString&); // stem
int iscompoundsymbol(ArgString&); // compound symbol
int isupper(ArgString&);
ArgString substring(ArgString&, int, int);
#endif
