#ifndef _SUPPORT_H
#pragma once
#define _SUPPORT_H

#include "ArgStr.h"
#include "InternalData.h"
// prototypes for support functions

void SetElapsedTime(long, long);
void GetElapsedTime(long&, long&);


int GetStart();
int GetEnd();

void SetStart(int);
void SetEnd(int);

int GetSourcecodeLines();
char* GetSourcecode(int);

int SourcecodeLoaded();

void SetSourcecode(MemoryFile&);

void ClearPendingSignals();

void SetDigits(int);
int GetDigits();

void SetFuzz(int);
int GetFuzz();

void SetForm(int);
int GetForm();

void SetSignalDescription(Signals, ArgString);
ArgString GetSignalDescription(Signals);

void SetSignalBeingProcessed(Signals);
Signals GetSignalBeingProcessed();

void PrepareLexers();

void SetBreak();
void SetIterate(ArgString);
void SetLeave(ArgString);
void SetEof();

int IsBreak();
int IsIterate();
int IsLeave();
int IsEof();

ArgString GetSource();
void SetSource(ArgString);
ArgString GetVersion();

ArgString GetLinein();
ArgString GetExternal();
ArgString GetPull();

void SetCurrentAddress(ArgString);
void SetPreviousAddress(ArgString);
ArgString& GetCurrentAddress();
ArgString& GetPreviousAddress();

void SetSignalDelayed(Signals);
void SetSignalReTurnOn(Signals);
int ProcessPendingSignals();
int PendingSignal();

ArgString GetDefaultAddress();

ArgString& GetSignalLabel(Signals);
void RaiseSignal(Signals);
void LowerSignal(Signals);
int SignalDelayed(Signals);
int SignalOn(Signals);
int SignalOff(Signals);
int ActionIsCall(Signals); // we should process this signal as a call
int ActionIsSignal(Signals); // we should process this signal as a signal
int SignalPending(Signals);

// these look at the glob.RaisedSignal
    
int SignalDelayed();
int SignalOn();
int SignalOff();
int LowerSignal();
int ActionIsCall();
int ActionIsSignal();
ArgString& GetSignalLabel();

void SetSignalPending(Signals);
void SetSignalOff(Signals);
void SetSignalOn(Signals, ArgString, Actions = ASignal);

void HasSymbolTable(int); // say that we have a symboltable here
int HasSymbolTable(); // check if we have a symboltable in this env

void SetErrorNumberForSignal(Signals);
void SetError(Errors);
void ClearError();

void SetVariableError(char*);

const char* GetErrorText(Errors);

ArgString& Args(int);
int& ArgsOmitted(int);
void SetNumArguments(int);
int GetNumArguments();

// these modify glob.ReasonForReturn and glob.ReturnValue
void SetExit(ArgString);
void SetReturn(ArgString);
void SetReturnValue(ArgString);
ArgString ReturnValue();

// these look at glob.ReasonForReturn
int IsExit();
int IsReturn();
int IsSignal();
int IsError();
int IsSyntaxError();
int IsHaltError();

#endif
